## mingw-w64-dwarfstack-2.3-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 4.1.1)

project(dwarfstack VERSION 2.3.0 LANGUAGES C CXX)

set(DWST_VERSION "2.3")
set(DWST_VER_NUM 2,3,0,0)
set(DWST_PRERELEASE 0)
set(DWST_COPYRIGHT_YEARS "2013-2025")

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(TARGET_NAME dwarfstack64)
else()
    set(TARGET_NAME dwarfstack32)
endif()

add_library(${TARGET_NAME} SHARED
    src/dwst-exception-dialog.c
    src/dwst-exception.c
    src/dwst-file.c
    src/dwst-location.c
    src/dwst-process.c
    mgwhelp/dwarf_pe.c
    dwarfstack-ver.rc

    libdwarf/dwarf_abbrev.c
    libdwarf/dwarf_alloc.c
    libdwarf/dwarf_debuglink.c
    libdwarf/dwarf_debugnames.c
    libdwarf/dwarf_die_deliv.c
    libdwarf/dwarf_dsc.c
    libdwarf/dwarf_error.c
    libdwarf/dwarf_find_sigref.c
    libdwarf/dwarf_fission_to_cu.c
    libdwarf/dwarf_form.c
    libdwarf/dwarf_frame.c
    libdwarf/dwarf_frame2.c
    libdwarf/dwarf_global.c
    libdwarf/dwarf_gnu_index.c
    libdwarf/dwarf_groups.c
    libdwarf/dwarf_harmless.c
    libdwarf/dwarf_init_finish.c
    libdwarf/dwarf_leb.c
    libdwarf/dwarf_line.c
    libdwarf/dwarf_loc.c
    libdwarf/dwarf_locationop_read.c
    libdwarf/dwarf_loclists.c
    libdwarf/dwarf_macro5.c
    libdwarf/dwarf_memcpy_swap.c
    libdwarf/dwarf_names.c
    libdwarf/dwarf_query.c
    libdwarf/dwarf_ranges.c
    libdwarf/dwarf_rnglists.c
    libdwarf/dwarf_string.c
    libdwarf/dwarf_str_offsets.c
    libdwarf/dwarf_tied.c
    libdwarf/dwarf_tsearchhash.c
    libdwarf/dwarf_util.c
    libdwarf/dwarf_xu_index.c

    zlib/adler32.c
    zlib/crc32.c
    zlib/inffast.c
    zlib/inflate.c
    zlib/inftrees.c
    zlib/uncompr.c
    zlib/zutil.c
)

set_source_files_properties(dwarfstack-ver.rc PROPERTIES
    COMPILE_DEFINITIONS "DWST_VER_STR=\\\"${DWST_VERSION}\\\";DWST_VER_NUM=${DWST_VER_NUM};DWST_PRERELEASE=${DWST_PRERELEASE};DWST_COPYRIGHT_YEARS=\\\"${DWST_COPYRIGHT_YEARS}\\\""
)

target_compile_options(${TARGET_NAME} PRIVATE
    -Wno-unused
    -Wno-pointer-to-int-cast
    -Wno-int-to-pointer-cast
)

target_compile_definitions(${TARGET_NAME} PRIVATE
    DWST_SHARED
    DW_TSHASHTYPE=uintptr_t
    LIBDWARF_STATIC
)

target_link_libraries(${TARGET_NAME} PRIVATE
    dbghelp
    gdi32
    stdc++
)

target_include_directories(${TARGET_NAME} PRIVATE
    mgwhelp
    libdwarf
    zlib
    PUBLIC
    include
)

=== Makefile ===

DWST_VERSION = 2.3
DWST_VER_NUM = 2,3,0,0
DWST_PRERELEASE = 0
DWST_COPYRIGHT_YEARS = 2013-2025

SRC_DIR := $(dir $(lastword $(MAKEFILE_LIST)))

HOSTPREFIX =
CC = $(HOSTPREFIX)gcc
AR = $(HOSTPREFIX)ar
WINDRES = $(HOSTPREFIX)windres
CPPFLAGS = -DNO_DBGHELP -DLIBDWARF_STATIC
OPT = -O3
LDFLAGS = -s
FRAME_POINTER = -fno-omit-frame-pointer -fno-optimize-sibling-calls
INCLUDE = -I$(SRC_DIR)libdwarf -I$(SRC_DIR)mgwhelp -I$(SRC_DIR)include
WARN = -Wall -Wextra -Wno-implicit-fallthrough
CFLAGS = $(CPPFLAGS) $(OPT) $(WARN) $(FRAME_POINTER) $(INCLUDE)
CFLAGS_STATIC = $(CFLAGS) -DDWST_STATIC
CFLAGS_SHARED = $(CFLAGS) -DDWST_SHARED
CFLAGS_LIBDWARF = $(CFLAGS) -DDW_TSHASHTYPE=uintptr_t \
		  -I$(SRC_DIR)zlib \
		  -Wno-unused \
		  -Wno-pointer-to-int-cast -Wno-int-to-pointer-cast


# libdwarf
DWARF_SRC_REL = \
		dwarf_abbrev.c \
		dwarf_alloc.c \
		dwarf_debuglink.c \
		dwarf_debugnames.c \
		dwarf_die_deliv.c \
		dwarf_dsc.c \
		dwarf_error.c \
		dwarf_find_sigref.c \
		dwarf_fission_to_cu.c \
		dwarf_form.c \
		dwarf_frame.c \
		dwarf_frame2.c \
		dwarf_global.c \
		dwarf_gnu_index.c \
		dwarf_groups.c \
		dwarf_harmless.c \
		dwarf_init_finish.c \
		dwarf_leb.c \
		dwarf_line.c \
		dwarf_loc.c \
		dwarf_locationop_read.c \
		dwarf_loclists.c \
		dwarf_macro5.c \
		dwarf_memcpy_swap.c \
		dwarf_names.c \
		dwarf_query.c \
		dwarf_ranges.c \
		dwarf_rnglists.c \
		dwarf_str_offsets.c \
		dwarf_string.c \
		dwarf_tied.c \
		dwarf_tsearchhash.c \
		dwarf_util.c \
		dwarf_xu_index.c \

DWARF_SRC = $(patsubst %,libdwarf/%,$(DWARF_SRC_REL))
DWARF_OBJ = $(patsubst %.c,%.o,$(DWARF_SRC))


# mgwhelp
DWARF_PE_SRC_REL = dwarf_pe.c \

DWARF_PE_SRC = $(patsubst %,mgwhelp/%,$(DWARF_PE_SRC_REL))
DWARF_PE_OBJ = $(patsubst %.c,%.o,$(DWARF_PE_SRC))


# zlib
ZLIB_SRC_REL = adler32.c \
	       crc32.c \
	       inffast.c \
	       inflate.c \
	       inftrees.c \
	       uncompr.c \
	       zutil.c \

ZLIB_SRC = $(patsubst %,zlib/%,$(ZLIB_SRC_REL))
ZLIB_OBJ = $(patsubst %.c,%.o,$(ZLIB_SRC))


# dwarfstack
DWST_SRC_REL = dwst-file.c \
	       dwst-process.c \
	       dwst-location.c \
	       dwst-exception.c \
	       dwst-exception-dialog.c \

DWST_HEADER_REL = dwarfstack.h \

DWST_SRC = $(patsubst %,src/%,$(DWST_SRC_REL))
DWST_OBJ = $(patsubst %.c,%.o,$(DWST_SRC))
DWST_DLL_OBJ = $(patsubst %.c,%.dll.o,$(DWST_SRC)) dwarfstack-ver.o


INC = include/dwarfstack.h
LIB = lib/libdwarfstack.a lib/libdwarfstack.dll.a
BIN = bin/dwarfstack.dll
BUILD = $(LIB) $(BIN) $(INC)

all: $(BUILD)

.SUFFIXES: .c .o .dll.o


src libdwarf mgwhelp zlib include lib bin:
	@mkdir -p $@


ifneq ($(SRC_DIR),./)

vpath %.c $(SRC_DIR)
vpath %.rc $(SRC_DIR)

$(DWST_OBJ) $(DWST_DLL_OBJ) : | src
$(DWARF_OBJ) : | libdwarf
$(DWARF_PE_OBJ) : | mgwhelp
$(ZLIB_OBJ) : | zlib

$(INC): $(SRC_DIR)$(INC) | include
	cp -fp $< $@

endif


share/licenses/dwarfstack/LICENSE.txt: $(SRC_DIR)LICENSE.txt
	@mkdir -p share/licenses/dwarfstack
	cp -fp $< $@


# libdwarf

$(DWARF_OBJ) $(DWARF_PE_OBJ): %.o: %.c
	$(CC) -c $(CFLAGS_LIBDWARF) -o $@ $<


# static library
.c.o:
	$(CC) -c $(CFLAGS_STATIC) -o $@ $<

lib/libdwarfstack.a: $(DWARF_OBJ) $(ZLIB_OBJ) $(DWARF_PE_OBJ) $(DWST_OBJ) | lib
	$(AR) rcs $@ $(DWARF_OBJ) $(ZLIB_OBJ) $(DWARF_PE_OBJ) $(DWST_OBJ)


# shared library
.c.dll.o:
	$(CC) -c $(CFLAGS_SHARED) -o $@ $<

dwarfstack-ver.o: dwarfstack-ver.rc $(lastword $(MAKEFILE_LIST))
	$(WINDRES) -DDWST_VER_STR=\\\"$(DWST_VERSION)\\\" -DDWST_VER_NUM=$(DWST_VER_NUM) -DDWST_PRERELEASE=$(DWST_PRERELEASE) -DDWST_COPYRIGHT_YEARS=\\\"$(DWST_COPYRIGHT_YEARS)\\\" $< $@

bin/dwarfstack.dll: $(DWARF_OBJ) $(ZLIB_OBJ) $(DWARF_PE_OBJ) $(DWST_DLL_OBJ) | lib bin
	$(CC) $(LDFLAGS) -shared -o $@ $(DWARF_OBJ) $(ZLIB_OBJ) $(DWARF_PE_OBJ) $(DWST_DLL_OBJ) -ldbghelp -Wl,--out-implib,lib/libdwarfstack.dll.a -lgdi32 -lstdc++

lib/libdwarfstack.dll.a: bin/dwarfstack.dll


clean:
	rm -rf $(DWARF_OBJ) $(ZLIB_OBJ) $(DWARF_PE_OBJ) $(DWST_OBJ) $(DWST_DLL_OBJ) lib bin


# install
PREFIX = /usr/local

install: $(BUILD)
	@mkdir -p $(PREFIX)/include $(PREFIX)/lib $(PREFIX)/bin
	cp -f $(INC) $(PREFIX)/include
	cp -f $(LIB) $(PREFIX)/lib
	cp -f $(BIN) $(PREFIX)/bin


# builds
build32 build64 build64a:
	@mkdir -p $@

FORCE:

build32/bin/dwarfstack.dll: FORCE | build32
	$(MAKE) -C build32 -f ../Makefile HOSTPREFIX=i686-w64-mingw32- bin/dwarfstack.dll

build64/bin/dwarfstack.dll: FORCE | build64
	$(MAKE) -C build64 -f ../Makefile HOSTPREFIX=x86_64-w64-mingw32- bin/dwarfstack.dll

build64a/bin/dwarfstack.dll: FORCE | build64a
	$(MAKE) -C build64a -f ../Makefile HOSTPREFIX=aarch64-w64-mingw32- bin/dwarfstack.dll

build32/dwarfstack-$(DWST_VERSION)-mingw.tar.xz: build32/bin/dwarfstack.dll
	$(MAKE) -C build32 -f ../Makefile HOSTPREFIX=i686-w64-mingw32- package

build64/dwarfstack-$(DWST_VERSION)-mingw.tar.xz: build64/bin/dwarfstack.dll
	$(MAKE) -C build64 -f ../Makefile HOSTPREFIX=x86_64-w64-mingw32- package

build64a/dwarfstack-$(DWST_VERSION)-mingw.tar.xz: build64a/bin/dwarfstack.dll
	$(MAKE) -C build64a -f ../Makefile HOSTPREFIX=aarch64-w64-mingw32- package

dwarfstack%.dll: build%/bin/dwarfstack.dll
	cp -fp $< $@


# package
packages: package-src package32 package64 package64a package-dlls

dwarfstack-$(DWST_VERSION)-mingw.tar.xz: $(BUILD) share/licenses/dwarfstack/LICENSE.txt
	@rm -f $@
	tar -cJf $@ $^

dwarfstack-$(DWST_VERSION).tar.xz:
	@rm -f $@
	CURDIR=`pwd`; cd $(SRC_DIR) && git archive "HEAD^{tree}" |xz >$$CURDIR/$@

dwarfstack-$(DWST_VERSION)-mingw%.tar.xz: build%/dwarfstack-$(DWST_VERSION)-mingw.tar.xz
	cp -fp $< $@

dwarfstack-$(DWST_VERSION)-dlls.7z: LICENSE.txt dwarfstack32.dll dwarfstack64.dll dwarfstack64a.dll
	@rm -f $@
	7z a -mx=9 $@ $^

package: dwarfstack-$(DWST_VERSION)-mingw.tar.xz

package-src: dwarfstack-$(DWST_VERSION).tar.xz

package32: dwarfstack-$(DWST_VERSION)-mingw32.tar.xz

package64: dwarfstack-$(DWST_VERSION)-mingw64.tar.xz

package64a: dwarfstack-$(DWST_VERSION)-mingw64a.tar.xz

package-dlls: dwarfstack-$(DWST_VERSION)-dlls.7z

=== examples/addr2line/Makefile ===

CC = gcc
OPT = -O3
LDFLAGS = -s
CFLAGS = $(OPT) -Wall -Wextra -I../../include -DDWST_STATIC


a2l.exe: a2l.c ../../lib/libdwarfstack.a
	$(CC) $(CFLAGS) -municode $(LDFLAGS) -o $@ $^

../../lib/libdwarfstack.a:
	$(MAKE) -C ../.. lib/libdwarfstack.a


clean:
	rm -f a2l.exe

=== examples/exception-dialog/Makefile ===

CC = gcc
OPT = -O3
CFLAGS = $(OPT) -g -Wall -Wextra -I../../include -fno-omit-frame-pointer -fno-optimize-sibling-calls -fno-schedule-insns2

LIBS=../../lib/libdwarfstack.dll.a


exception-dialog.exe: exception-dialog.c crasher.c $(LIBS)
	$(CC) $(CFLAGS) -mwindows -o $@ $^

$(LIBS):
	$(MAKE) -C ../.. $@

clean:
	rm -f exception-dialog.exe

=== examples/exception/Makefile ===

CC = gcc
OPT = -O3
CFLAGS = $(OPT) -g -Wall -Wextra -I../../include -fno-omit-frame-pointer -fno-optimize-sibling-calls -fno-schedule-insns2


exception.exe: exception.c crasher.c ../../lib/libdwarfstack.dll.a
	$(CC) $(CFLAGS) -o $@ $^

../../lib/libdwarfstack.dll.a:
	$(MAKE) -C ../.. lib/libdwarfstack.dll.a


clean:
	rm -f exception.exe

=== examples/leak-detector/Makefile ===

include inc/leaks.mk

CC = gcc
CXX = g++
OPT = -O3 -g
CFLAGS = $(OPT) $(LEAKS_CFLAGS)
LDFLAGS = $(LEAKS_LDFLAGS) -Wall -Wextra

all: leaks-c.exe leaks-cxx.exe noaccess.exe

leaks-c.exe: main-c.c leaks-c.c leaking-c.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

leaks-cxx.exe: main-cxx.cpp leaks-cxx.cpp leaking-c.c leaking-cxx.cpp
	$(CXX) $(CFLAGS) $(LDFLAGS) -o $@ $^

noaccess.exe: noaccess.c leaks-c.c leaking-c.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^


clean:
	rm -f *.exe

=== PKGBUILD ===
# Maintainer: Zoltan Gyarmati <zgyarmati@zgyarmati.de>

_realname=dwarfstack
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.3
pkgrel=1
pkgdesc="Provides stacktrace with source file/line information (mingw-w64)"
arch=('any')
mingw_arch=( 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/ssbssa/dwarfstack"
license=('spdx:LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
source=("https://github.com/ssbssa/${_realname}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "002-no-int-conversion.patch")
sha256sums=('2c3edcb6b0beb3861f5798a89b26eb53286dc4fc598667dfcca208cc7e6096d3'
            'c8a22b5d7e5e290f745d292518e85d0b2b3b484c4d011aaaf1faf97291b83883')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 --binary -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-${pkgver}

  apply_patch_with_msg \
    002-no-int-conversion.patch
}

build() {
  cp -r "${srcdir}/${_realname}-${pkgver}" "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  make CC=${CC}
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  make install PREFIX="${pkgdir}${MINGW_PREFIX}"
  install -D -m644 "${srcdir}/${_realname}-${pkgver}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
